Public Class ExpirationAuthorizationModule
  Implements System.Web.IHttpModule

  Public Sub Dispose() Implements System.Web.IHttpModule.Dispose
    'nothing to disponse of
  End Sub

  Public Sub Init(ByVal context As System.Web.HttpApplication) Implements System.Web.IHttpModule.Init
    AddHandler context.AuthorizeRequest, AddressOf Me.Authorize
  End Sub

  Private Sub Authorize(ByVal sender As Object, ByVal e As EventArgs)
    Dim application As HttpApplication = CType(sender, HttpApplication)

    If application.Context.Request.IsAuthenticated Then
      If Not application.Context.User.IsInRole("NonExpiring") Then

        Dim identity As ExpiringIdentity = _
                CType(application.Context.User.Identity, ExpiringIdentity)

        If identity.Expires < DateTime.Now Then
          'the users registration has expired
          application.Context.Response.Redirect("RegistrationExpired.aspx")
        End If
      End If
    End If
  End Sub
End Class
