using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Xml;
using System.IO;

namespace XMLChapterCS {
	/// <summary>
	/// Summary description for Listing12.
	/// </summary>
	public class Listing12 : System.Web.UI.Page {
		protected System.Web.UI.WebControls.DataGrid dgNews;
	
		private void Page_Load(object sender, System.EventArgs e) {
			//Fix dates to be schema "compatible" using DOM
			XmlDocument doc = new XmlDocument();
			doc.Load(Server.MapPath("Listing1.xml"));
			XmlNodeList dateNodes = doc.SelectNodes("//harvest_time");
			foreach (XmlNode dateNode in dateNodes) {
				DateTime newDate = DateTime.Parse(dateNode.InnerText);
				dateNode.InnerText = XmlConvert.ToString(newDate);
			}
			//Save updated XML to Stream
			MemoryStream ms = new MemoryStream();
			doc.Save(ms);
			ms.Position = 0;

			DataSet ds = new DataSet();
			//Load schema
			ds.ReadXmlSchema(Server.MapPath("Listing12.xsd"));
			//Load XML data into DataSet
			ds.ReadXml(ms);

			//Create DataView
			DataView view = ds.Tables[0].DefaultView;
			//Sort on date column
			view.Sort = "harvest_time DESC";
			this.dgNews.DataSource = view;
			this.dgNews.DataBind();
			ms.Close();
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e) {
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent() {    
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion
	}
}
