namespace XMLChapterCS {
	using System;
	using System.ComponentModel;
	using System.Drawing;
	using System.Web;
	using System.Web.UI;
	using System.Xml;
	using System.Xml.Schema;

	/// <summary>
	///		Summary description for ValidateSchema.
	/// </summary>
	public class Listing18 : System.Web.UI.Page {
		protected System.Web.UI.WebControls.Label lblOutput;
	
		public Listing18()	{
			Page.Init += new System.EventHandler(Page_Init);
		}

		protected void Page_Load(object sender, System.EventArgs e)	{
			//Define logging folder
			string logFile = Server.MapPath("Log.txt");
			string xmlFilePath = Server.MapPath("Listing18.xml");

			//Create schema collection object and add schema to it
			XmlSchemaCollection schemaCol = new XmlSchemaCollection();
			schemaCol.Add(String.Empty,Server.MapPath("Listing18.xsd"));

			//Create XmlValidator and call Validate() method
			XmlValidator validator = new XmlValidator();
			XmlValidationStatus status = 
				validator.Validate(xmlFilePath,schemaCol,null,false,logFile);
			if (status.Status) {
				this.lblOutput.Text = "<b>Validation was SUCCESSFUL!</b>";
				//Call method to process XML document for backend process
			} else {
				this.lblOutput.Text = "<b>Validation failed!</b><p />";
				this.lblOutput.Text += status.ErrorMessages;
			}
		}

		protected void Page_Init(object sender, EventArgs e){
			InitializeComponent();
		}
		private void InitializeComponent() {
			this.Load += new System.EventHandler(this.Page_Load);

		}
	}
}
