using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Xml.XPath;
using System.Text;

namespace XMLChapterCS {
	/// <summary>
	/// Summary description for Listing9.
	/// </summary>
	public class Listing9 : System.Web.UI.Page {
		protected System.Web.UI.WebControls.PlaceHolder phNews;
	
		private void Page_Load(object sender, System.EventArgs e) {
			StringBuilder sorted = new StringBuilder();
			//XPath statement
			string xpath = "/moreovernews/article/headline_text";

			//Create XPathDocument class so we can get a navigator
			XPathDocument doc = 
				new XPathDocument(Server.MapPath("Listing1.xml"));
			XPathNavigator nav = doc.CreateNavigator();

			//Compile xpath expression
			XPathExpression exp = nav.Compile(xpath);
			//Add a sort based upon the headline_text child text node
			exp.AddSort("text()",XmlSortOrder.Ascending,
				XmlCaseOrder.None,"",XmlDataType.Text);

			//select nodes so we can see the sort
			XPathNodeIterator it = nav.Select(exp);
			while (it.MoveNext()) {
				//Grab headline_text value
				string headline = it.Current.Value;
				//Move to article
				it.Current.MoveToParent();
				//Move to url
				it.Current.MoveToFirstChild();
				//Grab url
				string url = it.Current.Value;
				sorted.Append("<tr><td><a href=\"");
				sorted.Append(url);
				sorted.Append("\">");
				sorted.Append(headline);
				sorted.Append("</a></td></tr>");
			}		
			this.phNews.Controls.Add(new LiteralControl(sorted.ToString()));
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e) {
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent() {    
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion
	}
}
