<?xml version="1.0" encoding="UTF-8" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
    <xsl:import href="http://localhost/XMLChapterCS/XSLT/Import.xslt" />
	<xsl:variable name="formValuesDoc" select="document('../XML/FormValues.xml')" />
	<xsl:template match="/">
		<xsl:apply-templates />
	</xsl:template>
	
	<xsl:template match="form">
		<html>
			<body bgcolor="#ffffff">
				<xsl:call-template name="import" />
				<h2>XSLT Transformations in .NET 1.1</h2>
				<form method="{@method}" action="{@action}">
					<xsl:apply-templates />
				</form>
			</body>
		</html>
	</xsl:template>
	
	<xsl:template match="ctl">
		<xsl:choose>
			<xsl:when test="@type='textbox'">
				<xsl:if test="@label">
					<xsl:value-of select="@label" />&#xa0;&#xa0;
				</xsl:if>
				<input type="text" name="{@id}" id="{@id}">
					<xsl:attribute name="value">
						<xsl:value-of select="$formValuesDoc//form/ctl[@id=current()/@id]/@value" />
					</xsl:attribute>
				</input>
				<br />
			</xsl:when>
			<xsl:when test="@type='submit'">
				<input type="submit" name="{@id}" id="{@id}" value="{@text}" />
				<br />
			</xsl:when>
		</xsl:choose>
	</xsl:template>
</xsl:stylesheet>

  