Imports System.Xml.XPath
Imports System.Text

Public Class Listing8
  Inherits System.Web.UI.Page

#Region " Web Form Designer Generated Code "

  'This call is required by the Web Form Designer.
  <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

  End Sub
  Protected WithEvents lblOutput As System.Web.UI.WebControls.Label

  'NOTE: The following placeholder declaration is required by the Web Form Designer.
  'Do not delete or move it.
  Private designerPlaceholderDeclaration As System.Object

  Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
    'CODEGEN: This method call is required by the Web Form Designer
    'Do not modify it using the code editor.
    InitializeComponent()
  End Sub

#End Region

  Dim sb As New StringBuilder
  Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
    NavigateBooks()
  End Sub


  Private Sub NavigateBooks()
    Dim xmlPath As String = Server.MapPath("Listing7.xml")
    'Load XML into a non-editable structure
    'This is more efficient than the DOM
    Dim doc As New XPathDocument(xmlPath)
    'Create XPathNavigator by calling CreateNavigator() method
    Dim nav As XPathNavigator = doc.CreateNavigator()
    'Move to document
    nav.MoveToRoot()
    'Move to root element - bookstore
    nav.MoveToFirstChild()
    'Move to first book child element
    If nav.MoveToFirstChild() Then
      Do 'Walk through book elements
        WalkSiblings(nav)
      Loop While nav.MoveToNext()
    End If
    'Write out data found while navigating doc
    lblOutput.Text = sb.ToString()
  End Sub


  Private Sub WalkSiblings(ByVal nav As XPathNavigator)
    'Move to "title" element and get value
    Dim firstName As String = String.Empty
    Dim lastName As String = String.Empty
    nav.MoveToFirstChild()
    Dim title As String = nav.Value
    sb.Append((title + "<br />"))
    'Move back to book element
    nav.MoveToParent()
    'access author element under book
    Dim authorNode As XPathNodeIterator = _
      nav.SelectChildren("author", "")
    While authorNode.MoveNext()
      'Move to first-name element
      authorNode.Current.MoveToFirstChild()
      firstName = authorNode.Current.Value
      'Move to last-name element
      authorNode.Current.MoveToNext()
      lastName = authorNode.Current.Value
      sb.Append((firstName + " " + lastName + "<br />"))
    End While

    'Now move to price element
    Dim priceNode As XPathNodeIterator = _
      nav.SelectChildren("price", "")
    priceNode.MoveNext()
    'Write out value of price element
    sb.Append(("$" + priceNode.Current.Value + "<br />"))

    'Access other books by author
    'This demonstrates how we can move anywhere in the doc
    Dim otherBookNodes As XPathNodeIterator = _
      nav.Select(("//book[author/first-name='" + firstName + _
      "' and author/last-name='" + lastName + _
      "' and title != """ + title + """]/title"))
    sb.Append("<i>Other Books:</i> <br />")
    'Add other books to output
    If otherBookNodes.Count > 0 Then
      While otherBookNodes.MoveNext()
        sb.Append((otherBookNodes.Current.Value + "<br />"))
      End While
    Else
      sb.Append("None")
    End If
    sb.Append("<p />")
  End Sub

End Class
