<%@Page Language="VB" Debug="True" %>
<%@Import Namespace="System.Data" %>
<%@Import Namespace="System.Runtime.Remoting" %>

<script runat="server">

<%-------------------------------------------------------------%>

' assembly details for System.Data in version 1.1
Dim sFQName As String = "System.Data, Version=1.0.5000.0, " _
    & "Culture=neutral, PublicKeyToken=b77a5c561934e089"

Dim bLocal As Boolean   ' true if running on local machine

Sub Page_Load()

  ' check if running on local server
  Dim sPath As String = Request.Url.ToString()
  bLocal = (sPath.IndexOf("http://localhost/") = 0)

  ' display data using SqlClient classes first time
  If Not Page.IsPostback Then
    ShowData("Sql")
  End If

End Sub

<%-------------------------------------------------------------%>

Sub ShowData(sTypePrefix As String)

  ' set values of namespace and class prefix
  Dim sNameSpace As String = sTypePrefix
  If sNameSpace = "Sql" Then
    sNameSpace = "SqlClient"
  End If

  ' bind result to DataGrid to display data
  dgr1.DataSource = GetDataReader(sNameSpace, sTypePrefix)
  dgr1.DataBind()

End Sub

<%-------------------------------------------------------------%>

Function GetDataReader(sNameSpace As String, _
                       sTypePrefix As String) As Object

  Dim sSQL As String = "SELECT * FROM Categories"
  lblResult.Text = "<b>Using classes from the System.Data." _
                 & sNameSpace & " namespace</b><br />"
  Dim sCon As String = _
    ConfigurationSettings.AppSettings("Northwind" & sNameSpace _
                                       & "ConnectString")

  ' only show connection string if running on local server
  If bLocal Then
    lblResult.Text &= "Connection String: " & sCon & "<br/>"
  End If

  ' create class prefix, e.g. "System.Data.SqlClient.Sql"
  Dim sClassPrefix As String = "System.Data." & sNameSpace _
                             & "." & sTypePrefix

  ' create instance of provider-specific Connection class
  ' uses default constructor and returns a handle to
  ' the "wrapped" object instance via remoting
  ' requires import of System.Runtime.Remoting namespace
  Dim oHandle As ObjectHandle
  oHandle = Activator.CreateInstance(sFQName, _
                      sClassPrefix & "Connection")

  ' unwrap object and assign to local variable
  Dim oCon As Object = oHandle.Unwrap()

  ' create instance of provider-specific Command class
  oHandle = Activator.CreateInstance(sFQName, _
                      sClassPrefix & "Command")

  ' unwrap object and assign to local variable
  Dim oCmd As Object = oHandle.Unwrap()

  Try

    ' assign values to properties of new objects and execute
    oCon.ConnectionString = sCon
    oCmd.Connection = oCon
    oCmd.CommandText = sSQL
    oCon.Open()
    Return oCmd.ExecuteReader(CommandBehavior.CloseConnection)

  Catch oErr As Exception

    ' be sure to close connection if error occurs
    oCon.Close()
    lblResult.Text &= "ERROR: " & oErr.Message & "<br />"

  End Try

End Function

<%-------------------------------------------------------------%>

Sub ListBoxChanged(sender As Object, e As EventArgs)

  ShowData(lstNameSpace.SelectedItem.Value)

End Sub

</script>

<%-------------------------------------------------------------%>

<html>
<head>
<!-- #include file="../global/style.inc" -->
<title>Writing Provider-Independent Data Access Code</title>
</head>
<body>

<span class="heading">Writing Provider-Independent Data Access Code</span><hr />

<form runat="server">

  Select the namespace classes to use:
  <asp:DropDownList id="lstNameSpace" runat="server"
       OnSelectedIndexChanged="ListBoxChanged"
       AutoPostback="True">
    <asp:ListItem Text="System.Data.SqlClient" Value="Sql" />
    <asp:ListItem Text="System.Data.OleDb" Value="OleDb" />
    <asp:ListItem Text="System.Data.Odbc" Value="Odbc" />
  </asp:DropDownList>

  <p />

  <asp:Label id="lblResult" EnableViewState="False" runat="server" /><p />

  <asp:DataGrid id="dgr1" runat="server" />

</form>

<span class="cite">
Remember to edit the connection strings in your web.config
file for the Northwind sample database.
</span>
<hr />
<!-- #include file="../global/viewsource.inc" -->
<!-- #include file="../global/footer.inc" -->

</body>
</html>

