<%@Page Language="VB" Debug="True" %>
<%@Import Namespace="System.Data" %>
<%@Import Namespace="System.Data.SqlClient" %>

<script runat="server">

<%-------------------------------------------------------------%>

' change these to select a different order
Dim iOrderID As Integer = 10310
Dim sCustomerID As String = "THEBI"


Sub Page_Load()

  ' show fixed values for query in table
  lblOrderID.Text = iOrderID.ToString()
  lblCustomerID.Text = sCustomerID

End Sub


Sub ExecuteSproc(sender As Object, args As EventArgs)

  ' show <div> holding the list of parameters and result
  divParams.Visible = True

  ' hide <div> holding the stored procedure listing
  divSproc.Visible = False

  ' get connection string, create connection and command
  Dim sConnect As String = _
    ConfigurationSettings.AppSettings("NorthwindSqlClientConnectString")
  Dim oCon As New SqlConnection(sConnect)
  Dim oCmd As New SqlCommand("ParamDefaultProc", oCon)
  Dim iRows As Integer

  Try

    ' specify query type, add parameters and execute query
    oCmd.CommandType = CommandType.StoredProcedure
    oCmd.Parameters.Add("@OrderID", iOrderID)
    oCmd.Parameters.Add("@CustomerID", sCustomerID)
    If chkOrderDate.Checked Then
      oCmd.Parameters.Add("@OrderDate", DateTime.Parse(txtOrderDate.Text))
    End If
    If chkRequiredDate.Checked Then
      oCmd.Parameters.Add("@RequiredDate", DateTime.Parse(txtRequiredDate.Text))
    End If
    If chkShippedDate.Checked Then
      oCmd.Parameters.Add("@ShippedDate", DateTime.Parse(txtShippedDate.Text))
    End If
    If chkShipVia.Checked Then
      oCmd.Parameters.Add("@ShipVia", Integer.Parse(lstShipVia.SelectedValue))
    End If
    If chkFreight.Checked Then
      oCmd.Parameters.Add("@Freight", Decimal.Parse(txtFreight.Text))
    End If
    If chkShipName.Checked Then
      oCmd.Parameters.Add("@ShipName", txtShipName.Text)
    End If
    If chkShipAddress.Checked Then
      oCmd.Parameters.Add("@ShipAddress", txtShipAddress.Text)
    End If
    If chkShipCity.Checked Then
      oCmd.Parameters.Add("@ShipCity", txtShipCity.Text)
    End If
    If chkShipPostalCode.Checked Then
      oCmd.Parameters.Add("@ShipPostalCode", txtShipPostalCode.Text)
    End If
    If chkShipCountry.Checked Then
      oCmd.Parameters.Add("@ShipCountry", txtShipCountry.Text)
    End If

    ' execute procedure and see how many rows were affected
    oCon.Open()
    iRows = oCmd.ExecuteNonQuery()

    'close connection afterwards
    oCon.Close()

    ' display confirmation or error message. If RequiredDate value
    ' not specified the error will be recorded in Windows Event Log
    If iRows > 0 Then
      lblResult.Text = "Updated " & iRows.ToString() & " row(s)."
    Else
      lblResult.Text = "<font color='red'><b>ERROR: </b> No " _
                     & "rows were updated - see the " _
                     & "Application Log in Event Viewer</font>"
    End If


  Catch oErr As Exception

    ' be sure to close connection if error occurs
    ' can call Close more than once if required - no exception
    ' is generated if Connection is already closed
    oCon.Close()
    lblResult.Text = "<font color='red'><b>ERROR: </b>" & oErr.Message & "</font>"

  End Try

  ' now collect values from table to show what happened
  oCmd.CommandType = CommandType.Text
  oCmd.CommandText = "SELECT OrderID,CustomerID,OrderDate,RequiredDate," _
                   & "ShippedDate,ShipVia,Freight,ShipName, ShipAddress," _
                   & "ShipCity,ShipPostalCode,ShipCountry FROM Orders " _
                   & "WHERE OrderID = " & iOrderID.ToString()
  Try
    oCon.Open()
    Dim oReader As SqlDataReader = oCmd.ExecuteReader()
    If oReader.HasRows Then   ' set values in last column of table
      oReader.Read()
      lblOrderDate.Text = oReader("OrderDate").ToString()
      lblRequiredDate.Text = oReader("RequiredDate").ToString()
      lblShippedDate.Text = oReader("ShippedDate").ToString()
      lblShipVia.Text = oReader("ShipVia").ToString()
      lblFreight.Text = oReader("Freight").ToString()
      lblShipName.Text = oReader("ShipName").ToString()
      lblShipAddress.Text = oReader("ShipAddress").ToString()
      lblShipCity.Text = oReader("ShipCity").ToString()
      lblShipPostalCode.Text = oReader("ShipPostalCode").ToString()
      lblShipCountry.Text = oReader("ShipCountry").ToString()
    Else
      lblResult.Text &= "<br />ERROR: No rows returned."
    End If

  Catch oErr As Exception
    oCon.Close()
    lblResult.Text &= "<br /><font color='red'><b>ERROR: </b>" _
                   & oErr.Message & "</font>"
  End Try

End Sub


Sub ShowSproc(sender As Object, args As EventArgs)

  ' hide <div> holding the list of parameters and result
  divParams.Visible = False

  ' show <div> holding the stored procedure listing
  divSproc.Visible = True

End Sub

</script>

<%-------------------------------------------------------------%>

<html>
<head>
<!-- #include file="../global/style.inc" -->
<title>Using Default Values in a Stored Procedure</title>
</head>
<body>
<form runat="server">
<span class="heading">Using Default Values in a Stored Procedure</span><hr />

<div id="divParams" Visible="True" runat="server">
<!-- display paramaters, collect values and show result --->
<table border="0" cellspacing="6">

<tr align="left"><th>Set</th><th>Parameter</th><th>Type</th><th>Default</th><th>Value</th><th>Table Row Value</th></tr>

<tr><td align="center"><asp:Image ImageUrl="~/images/True.gif" runat="server" /></td>
<td>@OrderID</td><td>int</td><td>{none}</td>
<td><asp:Label id="lblOrderID" EnableViewState="False" runat="server" /></td></tr>

<tr><td align="center"><asp:Image ImageUrl="~/images/True.gif" runat="server" />
<td>@CustomerID</td><td>int</td><td>{none}</td>
<td><asp:Label id="lblCustomerID" EnableViewState="False" runat="server" /></td></tr>

<tr><td><asp:CheckBox id="chkOrderDate" runat="server"/></td>
<td>@OrderDate</td><td>datetime</td><td>NULL</td>
<td><asp:TextBox id="txtOrderDate" Text="03/10/2004" Columns="12" runat="server" /></td>
<td><asp:Label id="lblOrderDate" EnableViewState="False" runat="server" /></td></tr>

<tr><td><asp:CheckBox id="chkRequiredDate" Checked=True runat="server"/></td>
<td>@RequiredDate</td><td>datetime</td><td>NULL</td>
<td><asp:TextBox id="txtRequiredDate" Text="11/10/2004" Columns="12" runat="server" /></td>
<td><asp:Label id="lblRequiredDate" EnableViewState="False" runat="server" /></td></tr>

<tr><td><asp:CheckBox id="chkShippedDate" runat="server"/></td>
<td>@ShippedDate</td><td>datetime</td><td>NULL</td>
<td><asp:TextBox id="txtShippedDate" Text="09/10/2004" Columns="12" runat="server" /></td>
<td><asp:Label id="lblShippedDate" EnableViewState="False" runat="server" /></td></tr>

<tr><td><asp:CheckBox id="chkShipVia" runat="server"/></td>
<td>@ShipVia</td><td>int</td><td>1</td>
<td><asp:DropDownList id="lstShipVia" runat="server">
<asp:ListItem Text="1" /><asp:ListItem Text="2" /><asp:ListItem Text="3" />
</asp:DropDownList></td>
<td><asp:Label id="lblShipVia" EnableViewState="False" runat="server" /></td></tr>

<tr><td><asp:CheckBox id="chkFreight" runat="server"/></td>
<td>@Freight</td><td>money</td><td>25</td>
<td><asp:TextBox id="txtFreight" Text="12.50" Columns="5" runat="server" /></td>
<td><asp:Label id="lblFreight" EnableViewState="False" runat="server" /></td></tr>

<tr><td><asp:CheckBox id="chkShipName" runat="server"/></td>
<td>@ShipName</td><td>nvarchar(40)</td><td>NULL</td>
<td><asp:TextBox id="txtShipName" Text="Billy Jilly" Columns="25" runat="server" /></td>
<td><asp:Label id="lblShipName" EnableViewState="False" runat="server" /></td></tr>

<tr><td><asp:CheckBox id="chkShipAddress" runat="server"/></td>
<td>@ShipAddress</td><td>nvarchar(60)</td><td>NULL</td>
<td><asp:TextBox id="txtShipAddress" Text="777 West Park North" Columns="25" runat="server" /></td>
<td><asp:Label id="lblShipAddress" EnableViewState="False" runat="server" /></td></tr>

<tr><td><asp:CheckBox id="chkShipCity" runat="server"/></td>
<td>@ShipCity</td><td>nvarchar(15)</td><td>NULL</td>
<td><asp:TextBox id="txtShipCity" Text="Chesterfield" Columns="25" runat="server" /></td>
<td><asp:Label id="lblShipCity" EnableViewState="False" runat="server" /></td></tr>

<tr><td><asp:CheckBox id="chkShipPostalCode" runat="server"/></td>
<td>@ShipPostalCode</td><td>nvarchar(10)</td><td>NULL</td>
<td><asp:TextBox id="txtShipPostalCode" Text="AB1 2CD" Columns="25" runat="server" /></td>
<td><asp:Label id="lblShipPostalCode" EnableViewState="False" runat="server" /></td></tr>

<tr><td><asp:CheckBox id="chkShipCountry" runat="server"/></td>
<td>@ShipCountry</td><td>nvarchar(15)</td><td>NULL</td>
<td><asp:TextBox id="txtShipCountry" Text="England" Columns="25" runat="server" /></td>
<td><asp:Label id="lblShipCountry" EnableViewState="False" runat="server" /></td></tr>

</table>
</div>

<div id="divSproc" Visible="False" runat="server">
<!-- display stored procedure --->
Executing the SQL Server stored procedure:<pre>
CREATE PROCEDURE ParamDefaultProc
  @OrderID int,                        @CustomerID nchar(5),
  @OrderDate datetime = NULL,          @RequiredDate datetime = NULL,
  @ShippedDate datetime = NULL,        @ShipVia int = 1,
  @Freight money = 25,                 @ShipName nvarchar(40) = NULL,
  @ShipAddress nvarchar(60) = NULL,    @ShipCity nvarchar(15) = NULL,
  @ShipPostalCode nvarchar(10) = NULL, @ShipCountry nvarchar(15) = NULL
AS
IF @OrderDate IS NULL
  BEGIN
    SET @OrderDate = GETDATE()
  END
IF @RequiredDate IS NULL
  BEGIN
    RAISERROR('Procedure ParamDefaultProc: you must
              provide a value for the RequiredDate',
              1, 1) WITH LOG
    RETURN
  END
IF @ShipName IS NULL
  BEGIN
    SELECT @ShipName = CompanyName,  @ShipAddress = Address,
           @ShipCity = City,         @ShipPostalCode = PostalCode,
           @ShipCountry = Country
           FROM Customers
           WHERE CustomerID = @CustomerID
  END
UPDATE Orders SET
  OrderDate = @OrderDate,           RequiredDate = @RequiredDate,
  ShippedDate = @ShippedDate,       ShipVia = @ShipVia,
  Freight = @Freight,               ShipName = @ShipName,
  ShipAddress = @ShipAddress,       ShipCity = @ShipCity,
  ShipPostalCode = @ShipPostalCode, ShipCountry = @ShipCountry
WHERE
  OrderID = @OrderID
</pre>
</div>
<p />

<!-- controls to submit page --->
&nbsp;
<asp:Button Text="Execute" OnClick="ExecuteSproc" runat="server" />&nbsp; or
<asp:Button Text="Show" OnClick="ShowSproc" runat="server" />&nbsp; stored procedure<p />
<asp:Label id="lblResult" EnableViewState="False" runat="server" /><p />
</form>

<span class="cite">
Remember to edit the connection strings in web.config file for the Northwind
sample database, and<br />install the ParamDefaultProc stored procedure using the SQL
script provided in the databases folder.
</span>
<hr />
<!-- #include file="../global/viewsource.inc" -->
<!-- #include file="../global/footer.inc" -->

</body>
</html>

