<%@Page Language="VB" Debug="True" %>
<%@Register TagPrefix="ahh" Tagname="ClientDialog"
            Src="ascx/clientdialog.ascx" %>
<%-------------------------------------------------------------%>

<script runat="server">

Sub Page_Load()

  ' attach dialog events to controls every time page loads
  ' use options selected in page for cancel and submit params
  Dim sMessage As String = "This is the value of the MessageText parameter"
  ctlDialog.AttachDialog(ctlDialog.DialogType.Alert, "test1", "onclick", sMessage, optCancel.Checked, optSubmit.Checked)
  ctlDialog.AttachDialog(ctlDialog.DialogType.Confirm, "test2", "onclick", sMessage, optCancel.Checked, optSubmit.Checked)
  ctlDialog.AttachDialog(ctlDialog.DialogType.Prompt, "test3", "onclick", sMessage, optCancel.Checked, optSubmit.Checked)

  If Page.IsPostback Then

    ' collect the results from the dialogs
    lblResult.Text = "Control 1: <b>" & ctlDialog.GetDialogResult("test1").ToString() & "</b><br />"
    lblResult.Text &= "Control 2: <b>" & ctlDialog.GetDialogResult("test2").ToString() & "</b><br />"
    lblResult.Text &= "Control 3: <b>" & ctlDialog.GetDialogResult("test3").ToString() & "</b><br />"

  End If

End Sub

</script>

<%-------------------------------------------------------------%>

<html>
<head>
<!-- #include file="../global/style.inc" -->
<title>Alert, Prompt and Confirm Dialogs from a User Control</title>
</head>
<body>

<ahh:ClientDialog id="ctlDialog" runat="server" />

<span class="heading">Alert, Prompt and Confirm Dialogs from a User Control</span><hr />

<form id="frmMain" runat="server">

  Control 1:
  <input id="test1" Type="Submit" Value="alert" runat="server" />
  is a standard &lt;input type="submit"&gt; control linked to an Alert dialog<p />

  Control 2:
  <asp:Button id="test2" Text="confirm" runat="server" />
  is an ASP.NET Button control linked to a Confirm dialog<p />

  Control 3:
  <asp:CheckBox id="test3" AutoPostback="True" runat="server" />
  is an ASP.NET CheckBox control with AutoPostback="True" and linked to a Prompt dialog

  <hr />

  Cancel event after dialog is closed?
  <asp:RadioButton Text="Yes" id="optCancel" GroupName="CancelOptions" AutoPostback="True" runat="server" />&nbsp;
  <asp:RadioButton Text="No" id="optNoCancel" GroupName="CancelOptions" Checked="True" AutoPostback="True" runat="server" /><br />
  Submit &lt;form&gt; after dialog is closed?
  <asp:RadioButton Text="Yes" id="optSubmit" GroupName="SubmitOptions" AutoPostback="True" runat="server" />&nbsp;
  <asp:RadioButton Text="No" id="optNoSubmit" GroupName="SubmitOptions" Checked="True" AutoPostback="True" runat="server" /><br />
  Click to <asp:Button Text="submit" runat="server" /> form manually.

</form>

The values detected on a postback are:<br />
<asp:Label id="lblResult" EnableViewState="False" runat="server" />

<hr><span class="cite">
[<a href="../global/viewsource.aspx?compsrc=clientdialog.htm" target="_blank">view source</a>] &nbsp;
<!-- #include file="../global/footer.inc" -->

</body>
</html>

