<%@Page Language="VB" Debug="True" %>
<%@Import Namespace="System.Data" %>
<%@Import Namespace="System.Data.OleDb" %>

<%-------------------------------------------------------------%>
<%@Register TagPrefix="ahh" Tagname="IEDialog"
            Src="ascx/dialogwindows.ascx" %>
<%-------------------------------------------------------------%>

<script runat="server">

Sub Page_Load()

  If Not Page.IsPostback Then
    BindDataGrid(ctlDialog.GetWindowArgument("test1"), "CustomerID")
  End If

End Sub

<%-------------------------------------------------------------%>

Sub ReturnValue(sender As Object, e As DataGridCommandEventArgs)

  Dim iIndex As Integer = e.Item.ItemIndex
  If iIndex >= 0 Then
    ctlDialog.SetWindowResult("test1", dgr1.DataKeys(iIndex))
  End If

End Sub

<%-------------------------------------------------------------%>

Sub BindDataGrid(sCustID As String, sSortOrder As String)

  ' build connection to database
  Dim sConnect As String _
    = ConfigurationSettings.AppSettings("NorthwindOleDbConnectString")
  Dim sSQL As String = "SELECT CustomerID, CompanyName, City " _
                     & "FROM Customers WHERE CustomerID LIKE '" _
                     & sCustID & "%'"
  Dim oDS As New DataSet
  Dim oConn As New OleDbConnection(sConnect)
  Dim oDA As New OleDbDataAdapter(sSQL, sConnect)

  Try

    ' fill dataset table
    oDA.Fill(oDS, "Customers")

  Catch oErr As Exception

    ' display error message in page
    lblErr.Text &= oErr.Message & "<br />"

  End Try

  ' bind DataGrid to sorted DataView of Customers table
  Dim oView As DataView = oDS.Tables("Customers").DefaultView
  oView.Sort = sSortOrder
  dgr1.DataSource = oView
  dgr1.DataBind()

End Sub

<%-------------------------------------------------------------%>

Sub SortRows(Sender As Object, e As DataGridSortCommandEventArgs)

  ' runs when the column headings in the DataGrid are clicked
  ' get sort expression (name of column heading that was
  ' clicked), recreate DataSet and bind to the DataGrid
  BindDataGrid(ctlDialog.GetWindowArgument("test1"), _
               e.SortExpression.ToString())

End Sub

</script>

<%-------------------------------------------------------------%>

<html>
<head>

<!----------------------------------------->
<!-- required in order to force any forms on
 this page to post back to dialog window -->
<base target="_self">
<!----------------------------------------->

<!-- #include file="../global/style.inc" -->
<title>Page for New Window Dialog</title>
</head>
<body leftmargin="20" topmargin="10">

<ahh:IEDialog id="ctlDialog" runat="server" />

<span class="heading">Page for New Window Dialog</span><hr />

<form id="frmMain" runat="server">

  <asp:Label id="lblErr" EnableViewState="False"
             runat="server" /><p />

  <asp:DataGrid id="dgr1" runat="server"
       Font-Size="10" width="100%"
       Font-Name="Tahoma,Arial,Helvetica,sans-serif"
       BorderStyle="None" BorderWidth="0px"
       BackColor="#deba84"
       CellPadding="3" CellSpacing="0"
       GridLines="None"
       DataKeyField="CustomerID"
       AutoGenerateColumns="False"
       AllowSorting="True"
       OnSortCommand="SortRows"
       OnItemCommand="ReturnValue">
    <HeaderStyle Font-Bold="True" ForeColor="#ffffff"
                 BackColor="#b50055" />
    <ItemStyle BackColor="#ffffc0" />
    <Columns>
      <asp:ButtonColumn HeaderText="ID"
           DataTextField="CustomerID"
           SortExpression="CustomerID"
           HeaderStyle-HorizontalAlign="Center"
           ItemStyle-HorizontalAlign="Center" />
      <asp:BoundColumn DataField="CompanyName"
           HeaderText="Company Name"
           SortExpression="CompanyName" />
      <asp:BoundColumn DataField="City"
           HeaderText="City"
           SortExpression="City" />
    </Columns>
  </asp:DataGrid>

</form>

<hr />
<table width="100%" border="0" cellpadding="0" cellspacing="0">
<tr>
<td align="left"><!-- #include file="../global/viewsource.inc" --></td>
<td align="right"><input type="button" value="Close" onclick="window.close()" /></td>
</tr>
</table>

</body>
</html>

