<%@Page Language="VB" Debug="True" %>
<%@Import Namespace="System.Data" %>
<%@Import Namespace="System.Data.OleDb" %>

<%-------------------------------------------------------------%>

<script runat="server">

Sub Page_Load()

  If Not Page.IsPostback Then
    dtl1.DataSource = GetCustomers()
    dtl1.DataBind()
  End If

End Sub

<%-------------------------------------------------------------%>

Function GetCustomers() As OleDbDataReader

  Dim sSelect As String _
    = "SELECT CustomerID, CompanyName, City, Country, Phone " _
    & "FROM Customers WHERE CustomerID LIKE 'c%'"
  Return GetReader(sSelect)

End Function

<%-------------------------------------------------------------%>

Function GetOrders(sKey As String) As OleDbDataReader

  Dim sSelect As String _
    = "SELECT Orders.OrderID, Orders.OrderDate, " _
    & "Orders.RequiredDate, Orders.ShippedDate, Orders.Freight, " _
    & "Shippers.CompanyName As ShipperName " _
    & "FROM Orders JOIN Shippers " _
    & "ON Orders.ShipVia = Shippers.ShipperID " _
    & "WHERE CustomerID='" & sKey & "'"
  Return GetReader(sSelect)

End Function

<%-------------------------------------------------------------%>

Function GetReader(sSQL As String) As OleDbDataReader

  ' get DataReader for rows from Northwind tables
  Dim sConnect As String _
    = ConfigurationSettings.AppSettings("NorthwindOleDbConnectString")
  Dim oConnect As New OleDbConnection(sConnect)

  Try

    oConnect.Open()
    Dim oCommand As New OleDbCommand(sSQL, oConnect)
    Return oCommand.ExecuteReader(CommandBehavior.CloseConnection)

  Catch oErr As Exception

    ' be sure to close connection if error occurs
    If oConnect.State <> ConnectionState.Closed  Then
      oConnect.Close()
    End If

    ' display error message in page
    lblErr.Text = oErr.Message & "<p />"

  End Try

End Function

<%-------------------------------------------------------------%>

Sub BindOrdersGrid(sender As Object, e As DataListItemEventArgs)

  ' see what type of row (header, footer, item, etc.) caused the event
  Dim oType As ListItemType = CType(e.Item.ItemType, ListItemType)

  ' only process it if it's the Selected row
  If oType = ListItemType.SelectedItem Then

    ' get value of CustomerID for this row from DataKeys collection
    Dim sKey As String = dtl1.DataKeys(e.Item.ItemIndex)

    ' get a reference to the DataGrid control in this row
    Dim oGrid As DataGrid = CType(e.Item.FindControl("dgr1"), DataGrid)

    ' bind nested "orders" DataGrid to DataReader
    oGrid.DataSource = GetOrders(sKey)
    oGrid.DataBind()

  End If

End Sub

<%-------------------------------------------------------------%>

Function GetDataGridRef() As DataGrid

  ' get a reference to the DataGrid in the selected DataList row
  Dim oRow As DataListItem = dtl1.Items(dtl1.SelectedIndex)
  Return CType(oRow.FindControl("dgr1"), DataGrid)

End Function

<%-------------------------------------------------------------%>

Sub DoItemSelect(sender As Object, e As DataListCommandEventArgs)

  ' see if it was the Select button that was clicked
  If e.CommandName = "Select" Then

    ' set the SelectedIndex property of the list to this item's index
    dtl1.SelectedIndex = e.Item.ItemIndex
    dtl1.DataSource = GetCustomers()
    dtl1.DataBind()

  End If

  ' see if it was the Un-Select button that was clicked
  If e.CommandName = "UnSelect" Then

    ' set the SelectedIndex property of the list to -1
    dtl1.SelectedIndex = -1
    dtl1.DataSource = GetCustomers()
    dtl1.DataBind()

  End If

End Sub

<%-------------------------------------------------------------%>

Sub DoItemEdit(sender As Object, e As DataGridCommandEventArgs)

  ' get a reference to the DataGrid control in this row
  Dim oGrid As DataGrid = GetDataGridRef()

  ' set the EditItemIndex of the grid to this item's index
  oGrid.EditItemIndex = e.Item.ItemIndex

  ' bind grid to display row in new mode
  ' get CustomerID from the DataKeys collection of the DataList
  oGrid.DataSource = GetOrders(dtl1.DataKeys(dtl1.SelectedIndex))
  oGrid.DataBind()

End Sub

<%-------------------------------------------------------------%>

Sub DoItemUpdate(sender As Object, e As DataGridCommandEventArgs)

  ' get a reference to the DataGrid control in this row
  Dim oGrid As DataGrid = GetDataGridRef()

  ' get a reference to the text boxes
  Dim oOrdered As TextBox = CType(e.Item.FindControl("txtOrderDate"), TextBox)
  Dim oRequired As TextBox = CType(e.Item.FindControl("txtRequiredDate"), TextBox)
  Dim oShipped As TextBox = CType(e.Item.FindControl("txtShippedDate"), TextBox)
  Dim oFreight As TextBox = CType(e.Item.FindControl("txtFreight"), TextBox)

  ' verify that the values are valid
  Dim dOrderDate, dRequDate, dShipDate As DateTime
  Dim cFreight As Decimal
  Try
    dOrderDate = DateTime.Parse(oOrdered.Text)
  Catch
    lblErr.Text = "ERROR: Invalid value entered for Order Date<p />"
    Exit Sub
  End Try
  Try
    dRequDate = DateTime.Parse(oRequired.Text)
  Catch
    lblErr.Text = "ERROR: Invalid value entered for Required Date<p />"
    Exit Sub
  End Try
  Try
    dShipDate = DateTime.Parse(oShipped.Text)
  Catch
    lblErr.Text = "ERROR: Invalid value entered for Shipped Date<p />"
    Exit Sub
  End Try
  Try
    cFreight = Decimal.Parse(oFreight.Text)
  Catch
    lblErr.Text = "ERROR: Invalid value entered for Freight Cost<p />"
    Exit Sub
  End Try

  ' create a suitable SQL statement and execute it
  Dim sSQL As String
  sSQL = "UPDATE Orders SET OrderDate='" & dOrderDate.ToString("yyyy-MM-dd") & "', " _
       & "RequiredDate='" & dRequDate.ToString("yyyy-MM-dd") & "', " _
       & "ShippedDate='" & dShipDate.ToString("yyyy-MM-dd") & "', " _
       & "Freight=" & cFreight.ToString() & " " _
       & "WHERE OrderID=" & oGrid.DataKeys(e.Item.ItemIndex)
  ExecuteSQLStatement(sSQL)

  ' set EditItemIndex of grid to -1 to switch out of Edit mode
  oGrid.EditItemIndex = -1

  ' bind grid to display row in new mode
  ' get CustomerID from the DataKeys collection of the DataList
  oGrid.DataSource = GetOrders(dtl1.DataKeys(dtl1.SelectedIndex))
  oGrid.DataBind()

End Sub

<%-------------------------------------------------------------%>

Sub DoItemCancel(sender As Object, e As DataGridCommandEventArgs)

  ' get a reference to the DataGrid control in this row
  Dim oGrid As DataGrid = GetDataGridRef()

  ' set EditItemIndex of grid to -1 to switch out of Edit mode
  oGrid.EditItemIndex = -1

  ' bind grid to display row in new mode
  ' get CustomerID from the DataKeys collection of the DataList
  oGrid.DataSource = GetOrders(dtl1.DataKeys(dtl1.SelectedIndex))
  oGrid.DataBind()

End Sub

<%-------------------------------------------------------------%>

Sub ExecuteSQLStatement(sSQL)

  ' execute SQL statement against the original data source
  Dim sConnect As String _
    = ConfigurationSettings.AppSettings("NorthwindOleDbConnectString")
  Dim oConnect As New OleDbConnection(sConnect)

  Try

    oConnect.Open()
    Dim oCommand As New OleDbCommand(sSQL, oConnect)
    If oCommand.ExecuteNonQuery() <> 1 Then
      lblErr.Text &= "ERROR: Could not update the selected row<p />"
    End If
    oConnect.Close()

  Catch oErr As Exception

    ' be sure to close connection if error occurs
    If oConnect.State <> ConnectionState.Closed  Then
      oConnect.Close()
    End If

    ' display error message in page
    lblErr.Text &= "ERROR: " & oErr.Message & "<p />"

  End Try

End Sub

</script>

<%-------------------------------------------------------------%>
<%-------------------------------------------------------------%>

<html>
<head>
<!-- #include file="../global/style.inc" -->
<title>Master/Detail Display with a DataList and DataGrid</title>
</head>
<body>

<span class="heading">Master/Detail Display with a DataList and DataGrid</span><hr />

<form runat="server">


  <asp:Label id="lblErr" EnableViewState="False" runat="server" />

  <asp:DataList id="dtl1" Width="95%" runat="server"
       CellPadding="3" CellSpacing = "2"
       DataKeyField="CustomerID"
       OnItemCommand="DoItemSelect"
       OnItemDataBound="BindOrdersGrid" >
    <HeaderStyle Font-Bold="True" ForeColor="#ffffff"
                 BackColor="#b50055" />
    <FooterStyle Font-Bold="True" ForeColor="#ffffff"
                 BackColor="#b50055" />
    <ItemStyle BackColor="#FFF7E7" VerticalAlign="Top" />
    <AlternatingItemStyle BackColor="#FFFFC0" />

    <HeaderTemplate>
      <b>Customer List</b>
    </HeaderTemplate>

    <ItemTemplate>
      <asp:ImageButton CommandName="Select"
           ImageUrl="~/images/click-down.gif"
           Width="16" Height="17" runat="server"
           AlternateText="Click to view orders" />
      <%# Container.DataItem("CustomerID") %> &nbsp;
      <b><%# Container.DataItem("CompanyName") %></b> &nbsp;
      <%# Container.DataItem("City") %> &nbsp;
      <%# Container.DataItem("Country") %> &nbsp; &nbsp;
      Phone: <%# Container.DataItem("Phone") %> &nbsp;
    </ItemTemplate>

    <SelectedItemTemplate>
      <asp:ImageButton CommandName="UnSelect"
           ImageUrl="~/images/click-up.gif"
           Width="16" Height="17" runat="server"
           AlternateText="Click to hide orders" />
      <%# Container.DataItem("CustomerID") %> &nbsp;
      <b><%# Container.DataItem("CompanyName") %></b> &nbsp;
      <%# Container.DataItem("City") %> &nbsp;
      <%# Container.DataItem("Country") %> &nbsp; &nbsp;
      Phone: <%# Container.DataItem("Phone") %> &nbsp;

      <asp:DataGrid id="dgr1" runat="server"
           BorderStyle="None" BorderWidth="0" BackColor="#DEBA84"
           CellPadding="3" CellSpacing="0"
           DataKeyField="OrderID" Width="100%"
           OnEditCommand="DoItemEdit"
           OnUpdateCommand="DoItemUpdate"
           OnCancelCommand="DoItemCancel"
           AutoGenerateColumns="False" >
        <HeaderStyle BackColor="#c0c0c0" />
        <Columns>
          <asp:EditCommandColumn EditText="Edit"
               CancelText="Cancel" UpdateText="Update" />
          <asp:BoundColumn DataField="OrderID" HeaderText="Number"
                           ReadOnly="True" />
          <asp:TemplateColumn HeaderText="Ordered">
            <ItemTemplate>
              <%# DataBinder.Eval(Container.DataItem, "OrderDate", _
                                  "{0:dd MMM yyyy}") %>
            </ItemTemplate>
            <EditItemTemplate>
              <asp:TextBox Columns="8" id="txtOrderDate"
                   runat="server"
                   Text='<%# DataBinder.Eval(Container.DataItem, _
                             "OrderDate", "{0:dd MMM yyyy}") %>' />
            </EditItemTemplate>
          </asp:TemplateColumn>
          <asp:TemplateColumn HeaderText="Required">
            <ItemTemplate>
              <%# DataBinder.Eval(Container.DataItem, "RequiredDate", _
                                  "{0:dd MMM yyyy}") %>
            </ItemTemplate>
            <EditItemTemplate>
              <asp:TextBox Columns="8" id="txtRequiredDate"
                   runat="server"
                   Text='<%# DataBinder.Eval(Container.DataItem, _
                             "RequiredDate", "{0:dd MMM yyyy}") %>' />
            </EditItemTemplate>
          </asp:TemplateColumn>
          <asp:TemplateColumn HeaderText="Shipped">
            <ItemTemplate>
              <%# DataBinder.Eval(Container.DataItem, "ShippedDate", _
                                  "{0:dd MMM yyyy}") %>
            </ItemTemplate>
            <EditItemTemplate>
              <asp:TextBox Columns="8" id="txtShippedDate"
                   runat="server"
                   Text='<%# DataBinder.Eval(Container.DataItem, _
                             "ShippedDate", "{0:dd MMM yyyy}") %>' />
            </EditItemTemplate>
          </asp:TemplateColumn>
          <asp:TemplateColumn HeaderText="Freight"
               HeaderStyle-HorizontalAlign="Right"
               ItemStyle-HorizontalAlign="Right">
            <ItemTemplate>
              <%# DataBinder.Eval(Container.DataItem, _
                                  "Freight", "${0:f2}") %>
            </ItemTemplate>
            <EditItemTemplate>
              <asp:TextBox Columns="3" id="txtFreight" runat="server"
                   Text='<%# Container.DataItem("Freight") %>' />
            </EditItemTemplate>
          </asp:TemplateColumn>
          <asp:BoundColumn DataField="ShipperName"
               HeaderText="Via" ReadOnly="True"/>
        </Columns>
      </asp:DataGrid>

    </SelectedItemTemplate>

    <FooterTemplate>
      &nbsp;
    </FooterTemplate>

  </asp:DataList>

</form>

<span class="cite">
Remember to edit the connection strings in your web.config
file for the Northwind sample database.
</span>
<hr />
<!-- #include file="../global/viewsource.inc" -->
<!-- #include file="../global/footer.inc" -->

</body>
</html>

