<%@Page Language="VB" EnableViewState="False" Debug="True" %>
<%@Import Namespace="System.Data" %>
<%@Import Namespace="System.Data.OleDb" %>

<%-------------------------------------------------------------%>

<script runat="server">

Sub Page_Load()

  ' bind the data to the grid for display
  dgr1.DataSource = GetCustomers()
  dgr1.DataBind()

End Sub

<%-------------------------------------------------------------%>

Function GetCustomers() As OleDbDataReader

  Dim sSelect As String _
    = "SELECT CustomerID, CompanyName, City, Country " _
    & "FROM Customers WHERE CustomerID LIKE 'c%'"
  Return GetReader(sSelect)

End Function

<%-------------------------------------------------------------%>

Function GetOrders(sKey As String) As OleDbDataReader

  Dim sSelect As String _
    = "SELECT OrderID, OrderDate FROM Orders WHERE CustomerID='" & sKey & "'"
  Return GetReader(sSelect)

End Function

<%-------------------------------------------------------------%>

Function GetOrderLines(iKey As Integer) As OleDbDataReader

  Dim sSelect As String _
    = "SELECT Products.ProductID, Products.ProductName, " _
    & "[Order Details].Quantity, [Order Details].UnitPrice " _
    & "FROM [Order Details] JOIN Products " _
    & "ON [Order Details].ProductID = Products.ProductID " _
    & "WHERE OrderID=" & iKey.ToString()
  Return GetReader(sSelect)

End Function

<%-------------------------------------------------------------%>

Function GetReader(sSQL As String) As OleDbDataReader

  ' get DataReader for rows from Northwind tables
  Dim sConnect As String _
    = ConfigurationSettings.AppSettings("NorthwindOleDbConnectString")
  Dim oConnect As New OleDbConnection(sConnect)

  Try

    oConnect.Open()
    Dim oCommand As New OleDbCommand(sSQL, oConnect)
    Return oCommand.ExecuteReader(CommandBehavior.CloseConnection)

  Catch oErr As Exception

    ' be sure to close connection if error occurs
    If oConnect.State <> ConnectionState.Closed  Then
      oConnect.Close()
    End If

    ' display error message in page
    lblErr.Text = oErr.Message

  End Try

End Function

<%-------------------------------------------------------------%>

Sub BindOrdersGrid(sender As Object, e As DataGridItemEventArgs)

  ' see what type of row (header, footer, item, etc.) caused the event
  Dim oType As ListItemType = CType(e.Item.ItemType, ListItemType)

  ' only process it if it's an Item or AlternatingItem event
  If oType = ListItemType.Item _
  Or oType = ListItemType.AlternatingItem Then

    ' get value of CustomerID for this row from DataKeys collection
    Dim sKey As String = dgr1.DataKeys(e.Item.ItemIndex)

    ' get a reference to the DataGrid control in this row
    Dim oGrid As DataGrid = CType(e.Item.FindControl("dgr2"), DataGrid)

    ' bind nested "orders" DataGrid to DataReader
    oGrid.DataSource = GetOrders(sKey)
    oGrid.DataBind()

  End If

End Sub

<%-------------------------------------------------------------%>

Sub BindOrderItemsGrid(sender As Object, e As DataGridItemEventArgs)

  ' see what type of row (header, footer, item, etc.) caused the event
  Dim oType As ListItemType = CType(e.Item.ItemType, ListItemType)

  ' only process it if it's an Item or AlternatingItem event
  If oType = ListItemType.Item _
  Or oType = ListItemType.AlternatingItem Then

    ' get the value of the CustomerID column
    ' argument sender is a reference to the containing DataGrid
    Dim iKey As Integer = sender.DataKeys(e.Item.ItemIndex)

    ' get a reference to the DataGrid control in this row
    Dim oGrid As DataGrid = CType(e.Item.FindControl("dgr3"), DataGrid)

    ' bind nested "order details" DataGrid to DataReader
    oGrid.DataSource = GetOrderLines(iKey)
    oGrid.DataBind()

  End If

End Sub

</script>

<%-------------------------------------------------------------%>
<%-------------------------------------------------------------%>

<html>
<head>
<!-- #include file="../global/style.inc" -->
<title>Filling Nested DataGrids from a DataReader</title>
</head>
<body>

<span class="heading">Filling Nested DataGrids from a DataReader</span><hr />

<form runat="server">

  <asp:Label id="lblErr" EnableViewState="False" runat="server" /><p />

  <asp:DataGrid id="dgr1" runat="server"
       Font-Size="10" Font-Name="Tahoma,Arial,Helvetica,sans-serif"
       BorderStyle="None" BorderWidth="1px" BorderColor="#deba84"
       BackColor="#DEBA84" CellPadding="5" CellSpacing="1"
       DataKeyField="CustomerID"
       AutoGenerateColumns="False"
       OnItemDataBound="BindOrdersGrid" >
    <HeaderStyle Font-Bold="True" ForeColor="#ffffff" BackColor="#b50055" />
    <ItemStyle BackColor="#FFF7E7" VerticalAlign="Top" />
    <AlternatingItemStyle backcolor="#ffffc0" />
    <Columns>
      <asp:TemplateColumn HeaderText="Customer Details">
        <ItemTemplate>
          <b><%# Container.DataItem("CompanyName") %></b><br />
          City: <%# Container.DataItem("City") %><br />
          Country: <%# Container.DataItem("Country") %><br />
          CustomerID: "<%# Container.DataItem("CustomerID") %>"
        </ItemTemplate>
      </asp:TemplateColumn>
      <asp:TemplateColumn HeaderText="Order History">
        <ItemTemplate>

          <asp:DataGrid id="dgr2" runat="server"
               BorderStyle="None" BorderWidth="0" BackColor="#deba84"
               CellPadding="5" CellSpacing="2"
               DataKeyField="OrderID" Width="100%"
               AutoGenerateColumns="False"
               OnItemDataBound="BindOrderItemsGrid" >
            <HeaderStyle BackColor="#c0c0c0" />
            <ItemStyle Font-Bold="True" VerticalAlign="Top" />
            <Columns>
              <asp:BoundColumn DataField="OrderID" HeaderText="Number" />
              <asp:TemplateColumn HeaderText="Details">
                <ItemTemplate>
                  <asp:Label runat="server"
                       Text='<%# DataBinder.Eval(Container.DataItem, _
                             "OrderDate", "{0:dddd dd MMM yyyy}") %>' />

                  <asp:DataGrid id="dgr3" runat="server"
                       CellPadding="3" CellSpacing="0" Width="100%"
                       BorderStyle="None" BorderWidth="0"
                       AutoGenerateColumns="False" >
                    <HeaderStyle BackColor="#c0c0c0" />
                    <Columns>
                      <asp:BoundColumn DataField="ProductID"
                           HeaderText="ID" />
                      <asp:BoundColumn DataField="ProductName"
                           HeaderText="Product" />
                      <asp:BoundColumn DataField="Quantity"
                           ItemStyle-HorizontalAlign="Right"
                           HeaderStyle-HorizontalAlign="Right"
                           HeaderText="Qty" />
                      <asp:BoundColumn DataField="UnitPrice"
                           DataFormatString="${0:f2}"
                           ItemStyle-HorizontalAlign="Right"
                           HeaderStyle-HorizontalAlign="Right"
                           HeaderText="Price"/>
                    </Columns>
                  </asp:DataGrid>

                </ItemTemplate>
              </asp:TemplateColumn>
            </Columns>
          </asp:DataGrid>

        </ItemTemplate>
      </asp:TemplateColumn>
    </Columns>
  </asp:DataGrid>

</form>

<span class="cite">
Remember to edit the connection strings in your web.config
file for the Northwind sample database.
</span>
<hr />
<!-- #include file="../global/viewsource.inc" -->
<!-- #include file="../global/footer.inc" -->

</body>
</html>

