<%@Page Language="VB" EnableViewStateMac="False" Debug="True" %>

<script runat="server">

Sub Page_Load()
  If Not Page.IsPostback Then

    ' display the values in the Request collections
    lblRequest.Text &= "* QueryString collection:<br />"
    For Each oValue As String In Request.QueryString
      lblRequest.Text &= "&nbsp; " & oValue & " = " _
                      & Request.QueryString(oValue) & "<br />"
    Next
    lblRequest.Text &= "* Form collection:<br />"
    For Each oValue As String In Request.Form
      lblRequest.Text &= "&nbsp; " & oValue & " = " _
                      & Request.Form(oValue) & "<br />"
    Next

  End If
End Sub

' return to previous page and end current response
Sub GoBack(sender As Object, args As EventArgs)
  Response.Redirect("redirectpage.aspx", True)
End Sub

</script>

<!------------------------------------------------------------->

<html>
<head>
<!-- #include file="../global/style.inc" -->
<title>Accessing Request Values with EnableViewStateMac="False"</title>
</head>
<body>
<span class="heading">Accessing Request Values with EnableViewStateMac="False"</span><hr />

This page has <b>EnableViewStateMac="False"</b> in the <b>Page</b> directive to allow<br />
another page to post to it, without executing a check for viewstate corruption.<br />
Note that the SDK suggests the default for EnableViewStateMac is <b>False</b>, when<br />
in fact the default is <b>True</b>.<p />


<b>Values in the Request collections</b>:<br />
<asp:Label id="lblRequest" runat="server" />

<form runat="server">
  <asp:Button Text="Back" runat="server" OnClick="GoBack" />
</form>

<hr />
<!-- #include file="../global/viewsource.inc" -->
<!-- #include file="../global/footer.inc" -->
</body>
</html>

