<%@Page Language="VB" ClassName="ExecutePage" Debug="True" %>
<%@Import Namespace="System.IO" %>

<script runat="server">

' public properties exposed to other pages
Public ReadOnly Property TextValue As String
  Get
    Return txtThis.Text
  End Get
End Property

Public ReadOnly Property ListIndex As Integer
  Get
    Return lstThis.SelectedIndex
  End Get
End Property

Public ReadOnly Property DropList As DropDownList
  Get
    Return ddlThis
  End Get
End Property

' execute next page when button clicked
Sub DoExecute(sender As Object, args As EventArgs)

  ' create StringWriter and use it when executing target page
  Dim oWriter As New StringWriter()
  Server.Execute("catchexecute.aspx", oWriter)

  ' see if result should be HTML-encoded
  If optEncode.SelectedValue = "Yes" Then
    lblResult.Text = "<pre>" _
                   & Server.HtmlEncode(oWriter.ToString()) _
                   & "</pre>"
  Else
    lblResult.Text = oWriter.ToString()
  End if

End Sub

</script>

<!------------------------------------------------------------->

<html>
<head>
<!-- #include file="../global/style.inc" -->
<title>Using the Server.Execute Method to Capture Page Output</title>
</head>
<body>
<span class="heading">Using the Server.Execute Method to Capture Page Output</span><hr />

<form id="frmMain" runat="server">

Textbox (ID="txtThis"):
<asp:TextBox id="txtThis" Text="Some text" runat="server"/>
<p />
ListBox (ID="lstThis"):
<asp:ListBox id="lstThis" runat="server">
  <asp:ListItem Text="This is item 1" Value="Item1" />
  <asp:ListItem Text="This is item 2" Value="Item2" selected="True" />
  <asp:ListItem Text="This is item 3" Value="Item3" />
  <asp:ListItem Text="This is item 4" Value="Item4" />
</asp:ListBox>
<p />
DropDownList (ID="ddlThis"):
<asp:DropDownList id="ddlThis" runat="server">
  <asp:ListItem Text="This is item 1" Value="Item1" />
  <asp:ListItem Text="This is item 2" Value="Item2" />
  <asp:ListItem Text="This is item 3" Value="Item3" selected="True" />
  <asp:ListItem Text="This is item 4" Value="Item4" />
</asp:DropDownList>
<p />
Server.HtmlEncode results?
<asp:RadioButtonList id="optEncode" runat="server"
     RepeatDirection="Horizontal" RepeatLayout="Flow">
  <asp:ListItem Text="Yes" Selected="True" />
  <asp:ListItem Text="No" />
</asp:RadioButtonList>
<p />
<asp:Button id="btnExecute" Text="Execute" runat="server"
     OnClick="DoExecute" /> &nbsp;
</form>

<pre><asp:Label id="lblResult" runat="server" /></pre>

<hr />
<span class="cite">
[<a href="../global/viewsource.aspx?compsrc=catchexecute.htm" target="_blank">view source</a>] &nbsp;<!-- #include file="../global/footer.inc" -->
</body>
</html>
