<%@Page Language="VB" Debug="True" Trace="False" %>

<%-------------------------------------------------------------%>
<%@ Register TagPrefix="ahh" Namespace="Stonebroom"
             Assembly="maskedit" %>
<%-------------------------------------------------------------%>

<script runat="server">

Sub Page_Load()
  oCtrl.Mask = selMask.SelectedValue
  oCtrl.FontSize = selSize.SelectedValue
  oCtrl.Columns = selCols.SelectedValue
End Sub


Sub ShowProperties(Sender As Object, Args As EventArgs)
  lblResult.Text &= "Property values:" _
    & "<br />&nbsp; Mask: '" & Server.HtmlEncode(oCtrl.Mask) _
    & "<br />&nbsp; FontSize: " & oCtrl.FontSize _
    & "<br />&nbsp; Columns: " & oCtrl.Columns _
    & "<br />&nbsp; Text: '" & oCtrl.Text & "'<br />"
End Sub

Sub ClearTextbox(Sender As Object, Args As EventArgs)
  oCtrl.Text = ""
End Sub

Sub TextValueChanged(Sender As Object, Args As EventArgs)
  lblResult.Text &= "Detected TextChanged event for control " _
    & Sender.ID & ".<br />"
End Sub

</script>

<%-------------------------------------------------------------%>

<html>
<head>
<!-- #include file="../global/style.inc" -->
<title>Masked Edit Server Control Demonstration</title>
</head>
<body>

<span class="heading">Masked Edit Server Control Demonstration</span><hr />

<form id="frmMain" runat="server">

  Select Mask and Font size in the lists below and<br />
  press TAB to type in the masked edit box. The<br />
  browser status bar shows the expected character.<p />
  <asp:DropDownList id="selMask" OnSelectedIndexChanged="ClearTextbox" AutoPostback="True" runat="server">
    <asp:ListItem Value="nnnn-nn-nnTnn:nn:nn" Text="UTC Date and Time" />
    <asp:ListItem Value="Qnnnnn-LLnn" Text="Part Number" />
    <asp:ListItem Value="(nnn)-nnn-nnnn" Text="US Phone Number" />
    <asp:ListItem Value="LLn? nLL" Text="UK Postal Code" />
  </asp:DropDownList>
  <asp:DropDownList id="selSize" AutoPostback="True" runat="server">
    <asp:ListItem Value="10" Text="10 pt" />
    <asp:ListItem Value="12" Text="12 pt" />
    <asp:ListItem Value="16" Text="16 pt" />
  </asp:DropDownList>
  <asp:DropDownList id="selCols" AutoPostback="True" runat="server">
    <asp:ListItem Value="20" Text="20 columns" />
    <asp:ListItem Value="30" Text="30 columns" />
    <asp:ListItem Value="40" Text="40 columns" />
  </asp:DropDownList><p />

  <ahh:MaskEdit id="oCtrl" runat="server"
       OnTextChanged="TextValueChanged" />

  <p />
  <asp:Button id="btnSubmit" Text="Show Properties"
       OnClick="ShowProperties" runat="server" />

  <p />
  <asp:Label id="lblResult" EnableViewState="False" runat="server" />

</form>

<span class="cite">
Remember to copy the client-side script file 'maskedit.js' into a new<br />
subfolder named 'custom' within the 'aspnet_client' folder of your site.
</span>

<hr><span class="cite">
[<a href="../global/viewsource.aspx?compsrc=server-maskedit.htm" target="_blank">view source</a>] &nbsp;
<!-- #include file="../global/footer.inc" -->

</body>
</html>

