<%@Page Language="VB" Debug="True" Trace="False" %>

<%-------------------------------------------------------------%>
<%@ Register TagPrefix="ahh" Namespace="Stonebroom"
             Assembly="adaptive-spinbox" %>
<%-------------------------------------------------------------%>

<script runat="server">

Sub Page_Load()

  SetValues(Nothing, Nothing)

End Sub

<%-------------------------------------------------------------%>

Sub SetValues(oSender As Object, oArgs As EventArgs)

  spnTest.AutoPostback = CType(optAutoPost.SelectedValue, Boolean)
  spnTest.Caption = txtCaption.Text
  spnTest.ClientTarget = optTarget.SelectedIndex

  Try
    spnTest.Columns = txtColumns.Text
  Catch e As Exception
    lblResult.Text &= "<font color='red'><b>ERROR: </b>" & e.Message & "</font><br />"
  End Try

  spnTest.CssClass = optCssClass.SelectedValue

  Try
    spnTest.Increment = txtIncrement.Text
  Catch e As Exception
    lblResult.Text &= "<font color='red'><b>ERROR: </b>" & e.Message & "</font><br />"
  End Try

  Try
    spnTest.MaximumValue = txtMaxValue.Text
  Catch e As Exception
    lblResult.Text &= "<font color='red'><b>ERROR: </b>" & e.Message & "</font><br />"
  End Try

  Try
    spnTest.MinimumValue = txtMinValue.Text
  Catch e As Exception
    lblResult.Text &= "<font color='red'><b>ERROR: </b>" & e.Message & "</font><br />"
  End Try

  ' now show control property values
  ' collect details of current selection from spinbox
  optAutoPost.SelectedValue = spnTest.AutoPostback.ToString()
  txtCaption.Text = spnTest.Caption
  optCssClass.SelectedValue = spnTest.CssClass
  txtColumns.Text = spnTest.Columns.ToString()
  txtIncrement.Text = spnTest.Increment.ToString()
  txtMaxValue.Text = spnTest.MaximumValue.ToString()
  txtMinValue.Text = spnTest.MinimumValue.ToString()
  lblText.Text = spnTest.Text
  lblValue.Text = spnTest.Value.ToString()

End Sub

<%-------------------------------------------------------------%>

Sub SpinValueChanged(sender As Object, e As EventArgs)

  lblResult.Text &= "Detected ValueChanged event for control " _
                 & sender.ID & ". New value is " _
                 & sender.Text & "<br />"

End Sub


</script>

<%-------------------------------------------------------------%>
<%-------------------------------------------------------------%>

<html>
<head>

<!-- #include file="../global/style.inc" -->

<style type="text/css">

  .bluegray {background-color:gainsboro;
             font-family:Times new Roman;serif;
             font-size:12; color:darkblue}

  .reverse  {background-color:black;
             font-family:Tahoma,Helvetica,sans-serif;
             font-size:medium; color:white;
             font-weight:bold}

</style>
<title>Adaptive SpinBox Server Control Demonstration</title>
</head>
<body>

<span class="heading">Adaptive SpinBox Server Control Demonstration</span>
<form runat="server">

<hr />

<ahh:AdaptiveSpinBox id="spnTest" OnValueChanged="SpinValueChanged"
     runat="server" /><p />

<asp:Label id="lblResult" EnableViewState="False" runat="server" /><br />

<b>Set property values and click </b>
<asp:Button Text="Apply" OnClick="SetValues" runat="server" /><p />

AutoPostback:
<asp:RadioButtonList id="optAutoPost" RepeatLayout="Flow"
     RepeatDirection="Horizontal" runat="server" >
  <asp:ListItem Text="True" />
  <asp:ListItem Text="False" selected="True" />
</asp:RadioButtonList><br />

Caption:
<asp:TextBox id="txtCaption" Columns="20"
     Text="My Spinbox Control:" runat="server" /><br />

ClientTarget:
<asp:RadioButtonList id="optTarget" RepeatLayout="Flow"
     RepeatDirection="Horizontal" runat="server" >
  <asp:ListItem Text="Auto" selected="True" />
  <asp:ListItem Text="UpLevel" />
  <asp:ListItem Text="DownLevel" />
</asp:RadioButtonList><br />

Columns:
<asp:TextBox id="txtColumns" Columns="2" Text="3"
     runat="server" /><br />

CssClass:
<asp:RadioButtonList id="optCssClass" RepeatLayout="Flow"
     RepeatDirection="Horizontal" runat="server" >
  <asp:ListItem Text="{none}" selected="True" />
  <asp:ListItem Text="bluegray" />
  <asp:ListItem Text="reverse" />
</asp:RadioButtonList><br />

Increment:
<asp:TextBox id="txtIncrement" Columns="2" Text="1"
     runat="server" /><br />

MaximumValue:
<asp:TextBox id="txtMaxValue" Columns="2" Text="10"
     runat="server" /><br />

MinimumValue:
<asp:TextBox id="txtMinValue" Columns="2" Text="-10"
     runat="server" /><br />

Text:
"<asp:Label id="lblText" runat="server" />"<br />

Value:
<asp:Label id="lblValue" runat="server" /><br />

</form>

<hr />
<span class="cite">HINT: in "version 6" browsers you can place the input cursor in the text box and use<br />
the up, down, left and right arrow keys, and the Home and End keys, to set the value.</span><p />
<span class="cite">NOTE: Remember to copy the client-side script file named 'spinbox.js' into a new<br />
sub-folder named 'custom' within the 'aspnet_client' folder of your Web site.</span>

<hr><span class="cite">
[<a href="../global/viewsource.aspx?compsrc=adaptive-spinbox.htm" target="_blank">view source</a>] &nbsp;
<!-- #include file="../global/footer.inc" -->
</body>
</html>
