<%@Page Language="VB" Debug="True" %>

<%-------------------------------------------------------------%>

<%@Register TagPrefix="ahh" TagName="SpinBox" Src="ascx\user-spinbox.ascx" %>

<%-------------------------------------------------------------%>

<script runat="server">

Sub Page_Load()

  If Page.IsPostback Then
    SetValues(Nothing, Nothing)
  End If

End Sub

<%-------------------------------------------------------------%>

Sub ShowMembers(oSender As Object, oArgs As EventArgs)

  ' get a reference to the selected comboxbox control
  Dim oCtrl As Object = Page.FindControl(optCbo.SelectedValue)

  ' call ShowMembers method of spinbox control
  lblResult.Text = oCtrl.ShowMembers()

End Sub

<%-------------------------------------------------------------%>

Sub SetValues(oSender As Object, oArgs As EventArgs)

  ' get a reference to the selected spinbox control
  Dim oCtrl As Object = Page.FindControl(optCbo.SelectedValue)

  ' ----- set Columns property ------
  Try
    oCtrl.Columns = txtCols.Text
  Catch e As Exception
    lblResult.Text = "<font color='red'><b>ERROR: </b>" & e.Message & "</font>"
    Exit Sub
  End Try

  ' ----- set Increment property ------
  Try
    oCtrl.Increment = txtIncrement.Text
  Catch e As Exception
    lblResult.Text = "<font color='red'><b>ERROR: </b>" & e.Message & "</font>"
    Exit Sub
  End Try

  ' ----- set MinimumValue property ------
  Try
    oCtrl.MinimumValue = txtMinValue.Text
  Catch e As Exception
    lblResult.Text = "<font color='red'><b>ERROR: </b>" & e.Message & "</font>"
    Exit Sub
  End Try

  ' ----- set MaximumValue property ------
  Try
    oCtrl.MaximumValue = txtMaxValue.Text
  Catch e As Exception
    lblResult.Text = "<font color='red'><b>ERROR: </b>" & e.Message & "</font>"
    Exit Sub
  End Try

  ShowValues(Nothing, Nothing)

End Sub

<%-------------------------------------------------------------%>

Sub SetTextValue(oSender As Object, oArgs As EventArgs)

  ' get a reference to the selected spinbox control
  Dim oCtrl As Object = Page.FindControl(optCbo.SelectedValue)

  ' ----- set Text property ------
  Try
    oCtrl.Text = txtNewText.Text
  Catch e As Exception
    lblResult.Text = "<font color='red'><b>ERROR: </b>" & e.Message & "</font>"
    Exit Sub
  End Try

  ShowValues(Nothing, Nothing)

End Sub

<%-------------------------------------------------------------%>

Sub ShowValues(oSender As Object, oArgs As EventArgs)

  ' get a reference to the selected spinbox control
  Dim oCtrl As Object = Page.FindControl(optCbo.SelectedValue)

  ' use a StringBuilder to hold string for display
  Dim sResult As New StringBuilder("<b>Property Values:</b><br />")

  ' collect details of current selection from spinbox
  sResult.Append("AutoPostback: " & oCtrl.AutoPostback.ToString() & "<br />")
  sResult.Append("CssClass: &quot;" & oCtrl.CssClass & "&quot;<br />")
  sResult.Append("Columns: " & oCtrl.Columns.ToString() & "<br />")
  sResult.Append("Increment: " & oCtrl.Increment.ToString() & "<br />")
  sResult.Append("MaximumValue: " & oCtrl.MaximumValue.ToString() & "<br />")
  sResult.Append("MinimumValue: " & oCtrl.MinimumValue.ToString() & "<br />")
  sResult.Append("Text: &quot;" & oCtrl.Text & "&quot;<br />")
  sResult.Append("Value: " & oCtrl.Value.ToString() & "<br />")

  ' display results in the page
  lblResult.Text = sResult.ToString()

End Sub

</script>

<%-------------------------------------------------------------%>
<%-------------------------------------------------------------%>

<html>
<head>

<!-- #include file="../global/style.inc" -->

<style type="text/css">

  .bluegray {background-color:gainsboro;
             font-family:Times new Roman;serif;
             font-size:12; color:darkblue}

  .reverse  {background-color:black;
             font-family:Tahoma,Helvetica,sans-serif;
             font-size:medium; color:white;
             font-weight:bold}

</style>
<title>SpinBox User Control Features Demonstration</title>
</head>
<body>

<span class="heading">SpinBox User Control Features Demonstration</span>
<form runat="server">

  <hr />

  Simple SpinBox:
  <ahh:SpinBox id="spnTest1" runat="server" /><p />

  Styled SpinBox:
  <ahh:SpinBox id="spnTest2" CssClass="bluegray" runat="server" /><p />

  Styled AutoPostback SpinBox:
  <ahh:SpinBox id="spnTest3" CssClass="reverse" Columns="15"
       MaximumValue="10" MinimumValue="-10" Increment="5"
       AutoPostback="True" runat="server" />

  <hr />

  <b>Select SpinBox and specify action to apply</b>:<p />
  <asp:RadioButtonList id="optCbo" RepeatLayout="Flow" RepeatDirection="Horizontal" RepeatColumns="3" runat="server" >
    <asp:ListItem Value="spnTest1" Text="Simple &nbsp;" selected="True"/>
    <asp:ListItem Value="spnTest2" Text="Styled &nbsp;" />
    <asp:ListItem Value="spnTest3" Text="Styled AutoPostback" />
  </asp:RadioButtonList>
  <p />
  <asp:Button Text="&nbsp; &nbsp;" OnClick="ShowMembers" runat="server" /> &nbsp;
  Display the syntax by calling the ShowMembers method
  <p />
  <asp:Button Text="&nbsp; &nbsp;" OnClick="SetTextValue" runat="server" /> &nbsp;
  Set Text property to <asp:TextBox id="txtNewText" Columns="2" Text="18" runat="server" />
  <p />
  <asp:Button Text="&nbsp; &nbsp;" OnClick="SetValues" runat="server" /> &nbsp;
  Set Columns=<asp:TextBox id="txtCols" Columns="2" Text="10" runat="server" />
  Increment=<asp:TextBox id="txtIncrement" Columns="2" Text="5" runat="server" />
  MaximumValue=<asp:TextBox id="txtMaxValue" Columns="2" Text="50" runat="server" />
  MinimumValue=<asp:TextBox id="txtMinValue" Columns="2" Text="-100" runat="server" />
  <p />

  <asp:Label id="lblResult" EnableViewState="False" runat="server" />

</form>

<hr />
<span class="cite">HINT: in "version 6" browsers you can place the input cursor in the text box and use<br />
the up, down, left and right arrow keys, and the Home and End keys, to set the value.<p />
NOTE: Remember to copy the client-side script file named 'spinbox.js' into a new<br />
sub-folder named 'custom' within the 'aspnet_client' folder of your Web site.
</span>

<hr><span class="cite">
[<a href="../global/viewsource.aspx?compsrc=user-spinbox.htm" target="_blank">view source</a>] &nbsp;
<!-- #include file="../global/footer.inc" -->
</body>
</html>
