Imports System.ComponentModel
Imports System.Web.UI
Imports System.Web.UI.WebControls


Namespace SAMS.PageTemplates

    <ParseChildren(False)> _
    Public Class MasterPageControl
        Inherits System.Web.UI.WebControls.WebControl
        Implements INamingContainer

        Protected _logo As Image
        Protected _ads As AdRotator

        ' add client page objects to our own collection
        Friend _controlBin As ControlCollection
        Protected Overrides Sub AddParsedSubObject(ByVal obj As Object)

            If IsNothing(_controlBin) Then
                _controlBin = New ControlCollection(Me)
            End If
            Me._controlBin.Add(CType(obj, System.Web.UI.Control))

        End Sub

        Public Overrides ReadOnly Property Controls() As ControlCollection
            Get
                EnsureChildControls()
                Return MyBase.Controls
            End Get
        End Property

        Protected Overrides Sub CreateChildControls()

            Controls.Clear()

            If IsNothing(_controlBin) Then
                _controlBin = New ControlCollection(Me)
            End If

            _logo = New Image
            _logo.ImageUrl = "images/logo.gif"
            _logo.BorderStyle = BorderStyle.None
            Me.Controls.Add(_logo)

            _ads = New AdRotator
            _ads.AdvertisementFile = "adverts.xml"
            _ads.BorderStyle = BorderStyle.None
            Me.Controls.Add(_ads)

        End Sub

        Protected Overrides Sub Render(ByVal writer As System.Web.UI.HtmlTextWriter)

            writer.AddAttribute(HtmlTextWriterAttribute.Width, "100%")
            writer.AddAttribute(HtmlTextWriterAttribute.Border, "1")
            writer.RenderBeginTag(HtmlTextWriterTag.Table)

            ' header 
            writer.RenderBeginTag(HtmlTextWriterTag.Tr)
            writer.RenderBeginTag(HtmlTextWriterTag.Td)
            _logo.RenderControl(writer)
            writer.RenderEndTag() ' td
            writer.AddAttribute(HtmlTextWriterAttribute.Align, "right")
            writer.RenderBeginTag(HtmlTextWriterTag.Td)
            _ads.RenderControl(writer)
            writer.RenderEndTag() ' td
            writer.RenderEndTag() ' tr

            ' menu
            writer.RenderBeginTag(HtmlTextWriterTag.Tr)
            writer.AddAttribute(HtmlTextWriterAttribute.Valign, "top")
            writer.AddAttribute(HtmlTextWriterAttribute.Width, "15%")
            writer.RenderBeginTag(HtmlTextWriterTag.Td)
            writer.WriteLine("menu")
            writer.WriteLine("menu")
            writer.RenderEndTag() ' td

            ' content
            writer.AddAttribute(HtmlTextWriterAttribute.Valign, "top")
            writer.RenderBeginTag(HtmlTextWriterTag.Td)

            ' render the contained client controls
            Dim i As Integer
            For i = 0 To _controlBin.Count - 1
                _controlBin(i).RenderControl(writer)
            Next

            writer.RenderEndTag() ' td
            writer.RenderEndTag() ' tr

            ' footer
            writer.RenderBeginTag(HtmlTextWriterTag.Tr)
            writer.AddAttribute(HtmlTextWriterAttribute.Colspan, "2")
            writer.RenderBeginTag(HtmlTextWriterTag.Td)
            writer.WriteLine("footer content")
            writer.RenderEndTag() ' td
            writer.RenderEndTag() ' tr

            writer.RenderEndTag() ' table

        End Sub
    End Class


End Namespace
